define([
    'jquery'
], function ($) {
    'use strict';

    $.widget('filoblu.zendeskWidget', {
        options: {
            buttonRight: "0",
            backgroundColor: "#000000",
			textColor: "#ffffff",
			widgetPosition: "50%",
			zIndex : "9000"
        },

        _create: function () {
            var self = this;
            var buttonRight = (self.options.buttonRight == 1);
            var backgroundColor = self.options.backgroundColor;
			var textColor = self.options.textColor;
			var widgetPosition = self.options.widgetPosition;
			var zIndex = self.options.zIndex; 
            var widget = $('#customZendesk');
            var label = $('.zendesk-label');
            var icon = $('.zendesk-icon-container');
            var svg = $('.zendesk-icon');
            var widgetHeightCenter = (widget.outerHeight() / 2);//div by 2 for translateX(50%)
            var iconWidth = icon.outerWidth();
            var labelWidth = label.outerWidth();

            label.css('left', -labelWidth);
            label.css('color', textColor);

            icon.css('background', backgroundColor);
            svg.css('fill', textColor);

            if (buttonRight) {
                widget.css('right', widgetHeightCenter);
                widget.css('transform', 'translateX(50%) rotate(-90deg)');
            } else {
                widget.css('left', widgetHeightCenter);
                widget.css('transform', 'translateX(-50%) rotate(-90deg)');
            }
            widget.css('background', backgroundColor);
            widget.css('width', iconWidth + 'px');//init width prop as number for transition
			widget.css('opacity', 1);
			widget.css('top', widgetPosition);
			widget.css('z-index', zIndex);

            window.zE("webWidget", "hide");

            window.zE("webWidget:on", "close", function () {
                window.zE("webWidget", "hide");
                self.handleWidget('show');
            });

            widget.on('click', function () {
                window.zE("webWidget", "show");
                window.zE("webWidget", "open");
                self.handleWidget('hide');
            });

            mediaCheck({
                media: '(min-width: 992px)',
                entry: $.proxy(function () {
                    self.handleWidget('collapse');
                    widget.on('mouseenter', function () {
                        self.handleWidget('expand');
                    });

                    widget.on('mouseleave', function () {
                        self.handleWidget('collapse');
                    });
                }, this),
                exit: $.proxy(function () {
                    self.handleWidget('collapse');
                    widget.off('mouseleave');
                    widget.off('mouseenter');
                }, this)
            });
        },

        handleWidget: function (widgetEffect) {
            var self = this;
            var buttonRight = (self.options.buttonRight == 1);
            var widget = $('#customZendesk');
            var label = $('.zendesk-label');
            var icon = $('.zendesk-icon-container');
            var iconWidth = icon.outerWidth();
            var labelWidth = label.outerWidth();

            switch (widgetEffect) {
                case 'expand':
                    expandWidget();
                    break;

                case 'collapse':
                    collapseWidget();
                    break;

                case 'hide':
                    hide();
                    break;

                case 'show':
                    show();
                    break;
            }

            function collapseWidget() {
                widget.css('width', iconWidth + 'px');
                label.css('left', -labelWidth + 'px');
            }

            function expandWidget() {
                let symmetricPadding = buttonRight ? parseInt(icon.css('padding-left')) : parseInt(icon.css('padding-right'));
                let totalWidth = labelWidth + iconWidth + symmetricPadding;

                widget.css('width', totalWidth + 'px');
                label.css('left', iconWidth + 'px');
            }

            function hide() {
                $('#customZendesk').animate({opacity: 0}, 500);
            }

            function show() {
                $('#customZendesk').animate({opacity: 1}, 500);
            }
        }
    });

    return $.filoblu.zendeskWidget;
});
